SystemOrganization addCategory: #'Bitwize-Animation Tools'!

Object subclass: #BwScriptItem
	instanceVariableNames: 'position action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bitwize-Animation Tools'!

!BwScriptItem methodsFor: 'initializing' stamp: 'jtr 12/10/2004 11:32'!
action: aBlock
	action _ aBlock.! !

!BwScriptItem methodsFor: 'initializing' stamp: 'jtr 12/10/2004 11:33'!
action
	^ action.! !

!BwScriptItem methodsFor: 'initializing' stamp: 'jtr 12/10/2004 11:32'!
position: aPoint
	position _ aPoint asPoint.! !

!BwScriptItem methodsFor: 'initializing' stamp: 'jtr 12/10/2004 11:33'!
position
	^ position.! !

Object subclass: #MorphAgent
	instanceVariableNames: 'count play script morph loop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bitwize-Animation Tools'!

!MorphAgent methodsFor: 'playback and control' stamp: 'jtr 12/14/2004 20:42'!
loopOff
	loop _ false.! !

!MorphAgent methodsFor: 'adding frames' stamp: 'jtr 12/10/2004 11:49'!
newFrameMove: aPoint andDo: aBlock
	script add: (BwScriptItem new position: aPoint; action: aBlock).! !

!MorphAgent methodsFor: 'playback and control' stamp: 'jtr 12/10/2004 11:10'!
play
	play _ true.! !

!MorphAgent methodsFor: 'adding frames' stamp: 'jtr 12/18/2004 12:32'!
newFrameDo: aBlock 
	self newFrameMove: nil andDo: aBlock.! !

!MorphAgent methodsFor: 'adding frames' stamp: 'jtr 12/15/2004 15:51'!
newFrames: aNumber moveFrom: aPoint to: anotherPoint
	|p1 p2|
	p1 _ anotherPoint - aPoint.
	p2 _ p1 / aNumber.
	(1 to: (aNumber - 1)) do: [:i | self newFrameMove: (aPoint + (p2 * i))].
	self newFrameMove: anotherPoint.! !

!MorphAgent methodsFor: 'playback and control' stamp: 'jtr 12/15/2004 15:59'!
step
	|s p a o|
	play ifTrue: [
		count _ count + 1.
		o _ (morph owner) ifNotNil: [morph owner position] ifNil: [0@0].
		(count > script size) ifFalse: [
			s _ script at: count.
			s ifNotNil: [
				p _ s position.
				a _ s action.
				p ifNotNil: [morph position: o + p.].
				a ifNotNil: [a value: morph.].
			]
		]
		ifTrue: [loop ifFalse: [self stop.]. self reset.]
	].! !

!MorphAgent methodsFor: 'playback and control' stamp: 'jtr 12/11/2004 17:51'!
reset
	count _ 0.! !

!MorphAgent methodsFor: 'playback and control' stamp: 'jtr 12/14/2004 20:42'!
loopOn
	loop _ true.! !

!MorphAgent methodsFor: 'adding frames' stamp: 'jtr 12/10/2004 12:14'!
newFrameMove: aPoint 
	self newFrameMove: aPoint andDo: nil.! !

!MorphAgent methodsFor: 'playback and control' stamp: 'jtr 12/14/2004 20:42'!
loop
	^ loop.! !

!MorphAgent methodsFor: 'playback and control' stamp: 'jtr 12/10/2004 11:09'!
stop
	play _ false.! !

!MorphAgent methodsFor: 'initializing' stamp: 'jtr 12/15/2004 15:57'!
initializeOn: aMorph
	morph _ aMorph.
	morph setProperty: #myAgent toValue: self.
	script _ OrderedCollection new.
	play _ false.
	loop _ false.
	count _ 0.! !

Object subclass: #MorphFormCollector
	instanceVariableNames: 'morph forms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bitwize-Animation Tools'!

!MorphFormCollector methodsFor: 'as yet unclassified' stamp: 'jtr 11/30/2004 21:36'!
on: aMorph
	morph _ aMorph.
	forms _ OrderedCollection new.
	morph submorphsDo: [:m |
		(m isKindOf: ImageMorph orOf: SketchMorph) ifTrue: [forms add: (m form).].
	]
! !

!MorphFormCollector methodsFor: 'as yet unclassified' stamp: 'jtr 11/30/2004 21:37'!
frames
	^ forms asArray.! !

!MorphFormCollector class methodsFor: 'as yet unclassified' stamp: 'jtr 11/30/2004 21:36'!
on: aMorph
	^ self new on: aMorph.! !

RectangleMorph subclass: #BwPlayerMorph
	instanceVariableNames: 'actors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bitwize-Animation Tools'!

!BwPlayerMorph methodsFor: 'as yet unclassified' stamp: 'jtr 12/10/2004 12:11'!
stepTime
	^ 50! !

!BwPlayerMorph methodsFor: 'as yet unclassified' stamp: 'jtr 12/11/2004 17:04'!
step
	actors do: [:a | a step].! !

!BwPlayerMorph methodsFor: 'as yet unclassified' stamp: 'jtr 12/11/2004 17:06'!
initialize
	super initialize.
	actors _ OrderedCollection new.
	self color: Color white.
	self extent: 320@200.
	self clipSubmorphs: true.! !

!BwPlayerMorph methodsFor: 'as yet unclassified' stamp: 'jtr 12/11/2004 17:51'!
stop
	actors do: [:i | i stop].! !

!BwPlayerMorph methodsFor: 'as yet unclassified' stamp: 'jtr 12/11/2004 17:51'!
play
	actors do: [:i | i play].! !

!BwPlayerMorph methodsFor: 'as yet unclassified' stamp: 'jtr 12/11/2004 17:51'!
reset
	actors do: [:i | i reset].! !

!BwPlayerMorph methodsFor: 'as yet unclassified' stamp: 'jtr 12/13/2004 09:16'!
addMorph: aMorph
	actors add: (MorphAgent new initializeOn: aMorph).
	^ super addMorph: aMorph.! !
